# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/4/13
import argparse
import os
import random
import sys
sys.path.append(os.getcwd())
from common.common import Common
from common.public import task_fun
from common.scheduling_db import MysqlHelper
from benshanzhufu.benshanzhufu_recommend.benshanzhufu_recommend_scheduling import BenshanzhufuRecommend


def main(log_type, crawler, task, env):
    task_dict = task_fun(task)['task_dict']
    rule_dict = task_fun(task)['rule_dict']
    task_id = task_dict['task_id']
    select_user_sql = f"""select * from crawler_user_v3 where task_id={task_id}"""
    user_list = MysqlHelper.get_values(log_type, crawler, select_user_sql, env, action="")
    our_uid_list = []
    for user in user_list:
        our_uid_list.append(user["uid"])
    our_uid = random.choice(our_uid_list)
    Common.logger(log_type, crawler).info(f"调度任务:{task_dict}")
    Common.logger(log_type, crawler).info(f"抓取规则:{rule_dict}")
    Common.logger(log_type, crawler).info(f"用户列表:{user_list}\n")
    Common.logger(log_type, crawler).info('开始抓取 本山祝福小程序\n')
    BenshanzhufuRecommend.get_videoList(log_type=log_type,
                                        crawler=crawler,
                                        our_uid=our_uid,
                                        rule_dict=rule_dict,
                                        env=env)
    Common.del_logs(log_type, crawler)
    Common.logger(log_type, crawler).info('抓取完一轮\n')


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--task')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    main(log_type=args.log_type,
         crawler=args.crawler,
         task=args.task,
         env=args.env)