# -*- coding: utf-8 -*-
# @Author: lierqiang
# @Time: 2023/4/07
import argparse
import os
import sys

# import time

sys.path.append(os.getcwd())
from common.common import Common
# from common.feishu import Feishu
from douyin.douyin_recommend.recommend_dy import DyRecommend


def main(log_type, crawler, strategy, oss_endpoint, env, machine):
    our_id = 55252589
    Common.logger(log_type, crawler).info('开始抓取 抖音 推荐\n')
    DyRecommend.get_videolist(
        log_type=log_type,
        crawler=crawler,
        strategy=strategy,
        our_id=our_id,
        oss_endpoint=oss_endpoint,
        env=env,
        machine=machine)
    Common.del_logs(log_type, crawler)
    Common.logger(log_type, crawler).info('抓取完一轮\n')


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', default='recommend', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler', default='douyin')  ## 添加参数
    parser.add_argument('--strategy', default='推荐')  ## 添加参数
    parser.add_argument('--oss_endpoint', default='inner')  ## 添加参数
    parser.add_argument('--env', default='prod')  ## 添加参数
    parser.add_argument('--machine', default='aliyun')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    # print(args)
    main(log_type=args.log_type,
         crawler=args.crawler,
         strategy=args.strategy,
         oss_endpoint=args.oss_endpoint,
         env=args.env,
         machine=args.machine)
