# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/3/16
import argparse
import os
import sys
sys.path.append(os.getcwd())
from common.common import Common
from xiaoniangao.xiaoniangao_play.xiaoniangao_play import XiaoniangaoPlay


class Main:
    @classmethod
    def main(cls, log_type, crawler, env):
        if env == "dev":
            oss_endpoint = "out"
        else:
            oss_endpoint = "inner"
        for i in range(100):
            Common.logger(log_type, crawler).info(f'正在抓取小年糕播放量榜,第{i+1}页\n')
            XiaoniangaoPlay.get_videoList(log_type=log_type,
                                          crawler=crawler,
                                          strategy="播放量榜爬虫策略",
                                          oss_endpoint=oss_endpoint,
                                          env=env)
        Common.del_logs(log_type, crawler)
        Common.logger(log_type, crawler).info('抓取完一轮\n')


if __name__ == '__main__':
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    Main.main(log_type=args.log_type, crawler=args.crawler, env=args.env)
