# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/4/11
import argparse
import os
import sys

sys.path.append(os.getcwd())
from common.common import Common
from xigua.xigua_recommend.xigua_recommend import XiguaRecommend


def main(log_type, crawler, env):
    if env == "dev":
        oss_endpoint = "out"
    else:
        oss_endpoint = "inner"
    Common.logger(log_type, crawler).info('开始抓取 西瓜视频 推荐榜\n')
    XiguaRecommend.get_videoList(log_type, crawler, oss_endpoint, env)
    Common.del_logs(log_type, crawler)
    Common.logger(log_type, crawler).info('抓取完一轮，休眠 1 分钟\n')


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    main(log_type=args.log_type, crawler=args.crawler, env=args.env)